---
title: AudioTrackList
slug: Web/API/AudioTrackList
tags:
  - API
  - Audio
  - AudioTrackList
  - HTML DOM
  - Interface
  - Media
  - Reference
  - Track List
  - Tracks
  - list
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>AudioTrackList</code></strong> interface is used to represent a list of the audio tracks contained within a given HTML media element, with each track represented by a separate {{domxref("AudioTrack")}} object in the list.</span></p>

<p>Retrieve an instance of this object with {{domxref('HTMLMediaElement.audioTracks')}}. The individual tracks can be accessed using array syntax.</p>

<h2 id="Properties">Properties</h2>

<p><em>This interface also inherits properties from its parent interface, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("AudioTrackList.length", "length")}} {{ReadOnlyInline}}</dt>
 <dd>The number of tracks in the list.</dd>
</dl>

<h2 id="Event_handlers">Event handlers</h2>

<dl>
 <dt>{{domxref("AudioTrackList.onaddtrack", "onaddtrack")}}</dt>
 <dd>An event handler to be called when the {{event("addtrack")}} event is fired, indicating that a new audio track has been added to the media element.</dd>
 <dt>{{domxref("AudioTrackList.onchange", "onchange")}}</dt>
 <dd>An event handler to be called when the {{event("change")}} event occurs. This occurs when one or more tracks have been enabled or disabled by their {{domxref("AudioTrack.enabled", "enabled")}} flag being changed.</dd>
 <dt>{{domxref("AudioTrackList.onremovetrack", "onremovetrack")}}</dt>
 <dd>An event handler to call when the {{event("removetrack")}} event is sent, indicating that an audio track has been removed from the media element.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface also inherits methods from its parent interface, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt>{{domxref("AudioTrackList.getTrackById", "getTrackById()")}}</dt>
 <dd>Returns the {{domxref("AudioTrack")}} found within the <code>AudioTrackList</code> whose {{domxref("AudioTrack.id", "id")}} matches the specified string. If no match is found, <code>null</code> is returned.</dd>
</dl>

<h2 id="Events">Events</h2>

<dl>
 <dt><code><a href="/en-US/docs/Web/API/AudioTrackList/addtrack_event">addtrack</a></code></dt>
 <dd>Fired when a new audio track has been added to the media element.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/AudioTrackList/onaddtrack">onaddtrack</a></code> property.</dd>
 <dt><code><a href="/en-US/docs/Web/API/AudioTrackList/change_event">change</a></code></dt>
 <dd>Fired when a track has been enabled or disabled.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/AudioTrackList/onchange">onchange</a></code> property.</dd>
 <dt><code><a href="/en-US/docs/Web/API/AudioTrackList/removetrack_event">removetrack</a></code></dt>
 <dd>Fired when a new audio track has been removed from the media element.<br>
 Also available via the <code><a href="/en-US/docs/Web/API/AudioTrackList/onremovetrack">onremovetrack</a></code> property.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>In addition to being able to obtain direct access to the audio tracks present on a media element, <code>AudioTrackList</code> lets you set event handlers on the {{event("addtrack")}} and {{event("removetrack")}} events, so that you can detect when tracks are added to or removed from the media element's stream. See {{domxref("AudioTrackList.onaddtrack", "onaddtrack")}} and {{domxref("AudioTrackList.onremovetrack", "onremovetrack")}} for details and examples.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Getting_a_media_elements_audio_track_list">Getting a media element's audio track list</h3>

<p>To get a media element's {{domxref("AudioTrackList")}}, use its {{domxref("HTMLMediaElement.audioTracks", "audioTracks")}} property.</p>

<pre class="brush: js">var audioTracks = document.querySelector("video").audioTracks;</pre>

<h3 id="Monitoring_track_count_changes">Monitoring track count changes</h3>

<p>In this example, we have an app that displays information about the number of channels available. To keep it up to date, handlers for the {{event("addtrack")}} and {{event("removetrack")}} events are set up.</p>

<pre class="brush: js">audioTracks.onaddtrack = updateTrackCount;
audioTracks.onremovetrack = updateTrackCount;

function updateTrackCount(event) {
  trackCount = audioTracks.length;
  drawTrackCountIndicator(trackCount);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'media.html#audiotracklist', 'AudioTrackList')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'embedded-content-0.html#audiotracklist', 'AudioTrackList')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AudioTrackList")}}</p>
